clear;clc;
warning off all
load electricity.mat;
%% %%INITIAL DATA STRUCTURE%%%%%%%%%%%%%%
startpoint=1;
N=400;
insamplesize=N/2;
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
X=log(electricity(startpoint:startpoint+N-1,1))';
Y=log(electricity(startpoint:startpoint+N-1,2:end));
delta=1/252;
T=[electricity(end,2:end)];
Precision=1000000;
options=optimset('MaxFunEvals',	Precision,...
                     'MaxIter',Precision,...
                     'TolX',1e-30,...
                     'UseParallel','always',...
                     'TolFun',1e-30);

Step=14;
x=X(1:Step:end);
x0=[3.690,5.72,5.059,6.9905;];
[vecSeas, fval1]=fminsearch(@(vec) minimizeSeasonality(vec,x,delta*Step),x0,options);
%vecSeas(1)=0;
disp(vecSeas);
disp(fval1);
%%
%vecSeas(1)=0;
% t=(0:length(X)-1)*delta;
% Yseas=X-seasonality(vecSeas(1),vecSeas(2),vecSeas(3),vecSeas(4),t);
%  figure(1)
% plot(t,seasonality(vecSeas(1),vecSeas(2),vecSeas(3),vecSeas(4),t),t,X')
%  figure(2)
% plot(t/delta,Yseas)


%%
t=((startpoint:startpoint+insamplesize-1)-1)*delta;
%%%%%%%%%%%%%%%%%%%DESEASONALISED PRICES%%%%%%%%%%%%%%%%%%%
Yseas=X(1:insamplesize)-seasonality(vecSeas(1),vecSeas(2),vecSeas(3),vecSeas(4),t);
%%  
seasonalityParameters=vecSeas;
initcond=[      10,      10,     100 123;...
            1, .9, .5, -0.2;...
            .0001   .0001   .001 ,0] ;
% delta1=samplesize*delta;
% 
% 
% for i=1:100
%     [theta1,fval1]=fminsearch(@(vec) commMLE(vec,Yseas,delta),initcond(2,:),options);
%     initcond(2,:)=theta1;
% end;
% disp(fval1);
% disp(theta1);
% 


            %% Calibrate Risk and Noise Matrix
Precision=10000;
options=optimset('MaxFunEvals',	Precision,...
                     'MaxIter',Precision,...
                     'TolX',1e-32,...
                     'UseParallel','always',...
                     'TolFun',1e-32);
rVec0=[-1,-1];
C0=[rVec0 initcond(2,:) ones(1,length(T))*.99;];
[nVec, fval3]=fminsearch(@(nVec) MLEndim(nVec,Y(1:insamplesize,:),Yseas,...
                    @futprice,delta,t(1),T,vecSeas),C0,options);
                
C=diag(abs(nVec(7:end))+0.01);
rVec=nVec(1:2);
theta1=nVec(3:6);
disp(fval3);
disp(C);             
disp(theta1);
%% Set Up Particle filter
%N=N-60;
nParts=500;
particles=[Yseas(1)+randn([nParts 1]),zeros(nParts,1); zeros(nParts*N,2)];
%W=[ones(nParts,1)*1/nParts,zeros(nParts,N-1)];
W=[ones(nParts,1)/nParts,zeros(nParts,N-1)];
problem2.generator=@generatorR;
problem2.futprice=@futprice;
X_filtered=zeros(N-2,2);
tf=((startpoint:startpoint+N-1))*delta;
RMSE=zeros(length(T),N-1);
MRAEi=zeros(length(T),N-1);

%% PARTICLE FILTER LOOP

for i=1:N-1
    X_filtered(i,:)=W(:,i)'*particles((i-1)*nParts+1:i*nParts,:);
    [particles(i*nParts+1:(i+1)*nParts,:), W(:,i+1), RMSE(:,i), MRAEi(:,i)]=...
        particle_filter(problem2,theta1,vecSeas,Y(i+1,:)',C,delta,tf(i)...
                ,T,W(:,i),X_filtered(i,:),rVec);
    
end;

%% %%%%%%%%%%%%%%%Plot DATA%%%%%%%%%%%
f1=figure(1);clf;
tp=tf(1:end-1);
%a=plot(real(X_filtered(:,1)),'k');hold on
xlabel('Day Of reading');
ylabel('Log-Price')
eps=5;
RealProc=X(2:N)-seasonality(vecSeas(1),vecSeas(2),vecSeas(3),...
    vecSeas(4),tp) ;
idx = find(abs(RealProc - X_filtered(:,1)')< eps, N-1); 

y=real(X_filtered(:,1));
py=zeros(1,N-1)*NaN;
py(idx) = y(idx);
a=plot(py,'-o');hold on
%b=plot(real(X_filtered(:,2)),'k');
%A=real(X_filtered(:,2))+real(X_filtered(:,1));%*exp(-abs(theta1(3))*delta);
%c=plot(A,'--');
hold on
d=plot(RealProc,'r');
legend([a,d],'Process S_t','Observed price, deseasonalised','Location','Best');
print(f1,'-dpsc','Process Filtered_Random_Vol_ex1.eps')
%%
f2=figure(2);clf;
    RMSE=mean(RMSE,2);
    plot(T*delta,RMSE);
    ylabel('RMSE');
    xlabel('MATURITY');
print(f2,'-dpsc','Predicted_RMSE_Random_Vol_ex1.eps')    
%%
f3=figure(3);clf;
    MRAE=mean(MRAEi,2);
    
    plot(T*delta,MRAE*100,'.-');
    xlabel('Contract Maturity');
    ylabel('MRAE \%');
print(f3,'-dpsc','Predicted_MRAE_Random_Vol_ex1.eps')    
