function [Theta,RAE,MRAE,RMSE,fval,FutErrors] = main(myfunction,data, x0, Precision, samplesize,testsample )
global calType;
[n,m]=size(data);
n_new=samplesize+testsample;
%% Initial values
delta=1/252; %timestep weekly
T=data(n,2:m)*delta; % times to maturity 
x=log(data(1:n_new,1));    %vector of commodity prices price at time t=0
y=log(data(1:n_new,2:m)); %180 data points for calibration
y=y(~isinf(x),:);
x=x(~isinf(x));
n=length(x)-1;
D=T;
%% Calibration method choice 
if strcmp(calType,'GA')
    options=gaoptimset('Generations',Precision,...
                       'TolFun',1e-16,...
                       'HybridFcn',@fminsearch,...
                       'StallGenLimit',Precision/10,...
                       'UseParallel','always');
    [Theta, fval]=ga(@(c) myfunction(c,y(1:...
    samplesize,:),x(1),delta,T,'calibration',1),length(x0),...
    [],[],[],[],[],[],[],options);
else
    options=optimset('MaxFunEvals',	Precision,...
                     'MaxIter',Precision,...
                     'UseParallel','always',...
                     'TolFun',1e-16);
  %                   'FunValCheck','on',...
                     
    [Theta, fval]=fminsearch(@(c) myfunction(c,y(1:...
    samplesize,:),x(1),delta,T,'calibration',D),x0,options);
end;
%% Initialise output
futures=zeros(m-1,n-samplesize-1);
commodity=zeros(n-samplesize-1,1);
Tn=T-samplesize*delta;
k=0;
%% Generating the output
for i=samplesize:n-1

[futures(:,k+1), commodity(k+1)]=myfunction(Theta,y(samplesize+k,:)...
    ,x(samplesize+k),delta,Tn,'test',D);
k=k+1;
end;
 %%
 realComm=exp(x(samplesize+1:n));
 comcum=exp(commodity(1:end));
 X=realComm-comcum;
 N=length(X);
 RAE=abs(X)./realComm*100;
 MRAE=mean(RAE);
 RMSE=sqrt(sum((X).^2)/N);
 FutErrors=mean(abs(y(samplesize+1:n,:)'-futures(:,:))./y(samplesize+1:n,:)',2)';
end

