function [z,commodity ]= onestatefilter_rf(c,y,x0,delta,T,tag,~)
[m, n]=size(y);
mu=c(1);
theta=abs(c(2));
kap=abs(c(3))+0.01;
Sigma=abs(c(4));
Q=eye(n)*(abs(c(5))+0.01);
QQ=Q^2;
p=abs(c(6));
lambda=c(7);

an=mu+lambda*Sigma;
x_old=[x0 zeros(1,m)];
x_new=zeros(1,m+1);
B=exp(-kap*delta);
g=mu/kap*(1-exp(-kap*delta));
RR=Sigma^2*0.5/kap*(1-exp(-2*kap*delta))+theta/kap/kap*(1-exp(-kap*delta))^2;
L=T'*ones(1,m+2);
j=ones(n,1)*(0:m+1).*delta;
Tc=(L-j);
A=exp(-kap*Tc);
At=A';
y=y';
BB=B^2;
d=(an)/kap*(1-exp(-kap*Tc))+Sigma^2*0.25/kap*(1-exp(-2*kap*Tc))+theta/2/kap/kap*(1-exp(-kap*Tc)).^2;
switch lower(tag)
    case {'calibration'}
        z=0;
        for i=2:m
        x_new(:,i-1)=B*x_old(:,i-1)+g;
        v=y(:,i)-(A(:,i)*x_new(:,i-1)+d(:,i));
        sig=A(:,i)*p*At(i,:)+QQ;
        k=p*At(i,:)/sig;
        x_old(:,i)=x_new(:,i-1)+k*v;
        p=BB*p+RR-BB*p^2*At(i,:)*(sig\A(:,i));
        z=z+log(det(sig))+v'*(sig\v);
        end;
       
    
    case {'test'}
        commodity=B*x_old(:,1)+g;
        z=A(:,2)*commodity+d(:,2);   
        
end

