clc;
clear;
load gasoline.mat;
load HBnatgas.mat;
load lightoil.mat;
warning off all;
%Choice of calibration algorithm GA for genetic algorithm, any other value
%for fminsearch
%Parallelise the problem: set number of workers to 4;
%matlabpool open local 4;
Precision=20000; %number of function evaluations and maximum iterations 
%in case of genetic algorithm number of generations.
calibrationsample=300; % number of datapoints for calibration
testsample=301; % number of datapoints for out-of-sample performance
%% Setup parameters for parallel computation

% funchandle is a vector of functions we are going to test
%                                       k
func_handle={@onestatefilter,...        %1
            @onestatefilter_rf,...      %2
            @seasonalityfilter,...      %3   
            @stochalphafilter,...       %4
            @twostatefilter,...         %5
            @twostatefilterseasonality};%6
        
% initval_M is a vector of initial values for calibration with following
% structure:
%[Number of parameters initial_values]


initval_M=[5      1 1 0.1 .1 10 0 0 0 0 0 0 0 0 0;... % alpha, kappa, sigma, c, P0
           6     .1 1 .2 2 .1 0 0 0 0 0 0 0 0 0;...     % alpha, kappa, sigma, c, P0, lambda
           9     .1 1 .2 2 .1 0 0 0 0  0 0 0 0 0;...    %alpha, kappa, sigma, c, P0, lambda, phi, zeta, psi
           10    .1 1 .2 2 .1 .2 .3 .4 .2 10  0 0 0 0;...    % alpha, kappa, sigma, c, P0, lambda, phi, zeta, psi, eta
           11    .1 1 .2 .2 .2 .2 .1 2 2 10 .1 0 0 0;...     % alpha, kappa1,kappa2, sigma1,sigma2 c, beta, lambda1, lambda2,  P01, P02
           14    .1 1 .2 .2 .2 .2 .1 2 2 10 .1 0 0 0 ];     % alpha, kappa1,kappa2, sigma1,sigma2 c, beta, lambda1, lambda2,  P01, P02, phi, zeta, psi
%% Initialise containers for outputs
            gasolineTheta=zeros(6,12);
            natgasTheta=zeros(6,12);
            lightoilTheta=zeros(6,12);
            gasolineRAE=zeros(calibrationsample,6);
            gasolineRMSE=zeros(1,6);
            gasolinefval=zeros(1,6);
            gasolineMRAE=zeros(1,6);
            natgasRAE=zeros(calibrationsample,6);
            natgasRMSE=zeros(1,6);
            natgasfval=zeros(1,6);
            natgasMRAE=zeros(1,6);
            lightoilRAE=zeros(calibrationsample,6);
            lightoilRMSE=zeros(1,6);
            lightoilfval=zeros(1,6);
            lightoilMRAE=zeros(1,6);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%            
tic;

for k=1:2
        n=round(initval_M(k,1));
        display(['Evaluating ', num2str(k), ' function ', func2str(func_handle{k})]);
        [gasolineTheta(k,1:n),gasolineRAE(:,k),gasolineMRAE(k),...
            gasolineRMSE(k),gasolinefval(k),EGS,RGS]=VaRmain(func_handle{k},...
            gasoline,initval_M(k,2:(1+initval_M(k,1))),...
            Precision,calibrationsample,testsample);
        if k<6
            initval_M(k+1,2:(1+initval_M(k,1)))=gasolineTheta(k,1:n);
        end;
        if k==4
            initval_M(k+1,2:(1+initval_M(k+1,1)))=...
            [gasolineTheta(k,1) gasolineTheta(k,2) 0.00001 gasolineTheta(k,3) 0 gasolineTheta(k,4) 0 gasolineTheta(k,6) 0 gasolineTheta(k,5) 0 ];
        end;
end;             
gasolineTheta(:,2)=abs(gasolineTheta(:,2))+0.01;
gasolineTheta(1:4,3:4)=abs(gasolineTheta(1:4,3:4));
gasolineTheta(1:4,4)=gasolineTheta(1:4,4)+.01;
gasolineTheta(5:6,3)=abs(gasolineTheta(5:6,3))+0.0001;
gasolineTheta(5:6,4:5)=abs(gasolineTheta(5:6,4:5));
gasolineTheta(1:4,5)=abs(gasolineTheta(1:4,5));
gasolineTheta(5:6,10:11)=abs(gasolineTheta(5:6,10:11));
sigGS=gasolineTheta(2,3);
initval_M(1,2:6)=[1.26 10 0 1 100];
for k=1:2
        n=round(initval_M(k,1));
        display(['Evaluating ', num2str(k), ' function ', func2str(func_handle{k})]);
        [natgasTheta(k,1:n),natgasRAE(:,k),natgasMRAE(k),natgasRMSE(k),...
            natgasfval(k),ENG,RNG]=VaRmain(func_handle{k},...
            HBnatgas,initval_M(k,2:(1+initval_M(k,1))),...
            Precision,calibrationsample,testsample);
        if k<6
         initval_M(k+1,2:(1+initval_M(k,1)))=natgasTheta(k,1:n);
        end;
        if k==4
            initval_M(k+1,2:(1+initval_M(k+1,1)))=...
                [natgasTheta(k,1) natgasTheta(k,2) 0 natgasTheta(k,3) 0 natgasTheta(k,4) 0 natgasTheta(k,6) 0 natgasTheta(k,5) 0 ];
        end;
end;
natgasTheta(:,2)=abs(natgasTheta(:,2))+0.01;
natgasTheta(1:4,3:4)=abs(natgasTheta(1:4,3:4));
natgasTheta(1:4,4)=natgasTheta(1:4,4)+.01;
natgasTheta(5:6,3)=abs(natgasTheta(5:6,3))+0.0001;
natgasTheta(5:6,4:5)=abs(natgasTheta(5:6,4:5));
natgasTheta(1:4,5)=abs(natgasTheta(1:4,5));
natgasTheta(5:6,10:11)=abs(natgasTheta(5:6,10:11));
sigNG=natgasTheta(2,3);
initval_M(1,2:6)=[5 10 .1 1 100];
for k=1:2
        n=round(initval_M(k,1));
        display(['Evaluating ', num2str(k), ' function ', func2str(func_handle{k})]);
        [lightoilTheta(k,1:n),lightoilRAE(:,k),lightoilMRAE(k),...
            lightoilRMSE(k),lightoilfval(k),ELO,RLO]=VaRmain(func_handle{k},...
            lightoil,initval_M(k,2:(1+initval_M(k,1))),...
            Precision,calibrationsample,testsample);
        if k<6
          initval_M(k+1,2:(1+initval_M(k,1)))=lightoilTheta(k,1:n);
        end;
        if k==4
            initval_M(k+1,2:(1+initval_M(k+1,1)))=...
                [lightoilTheta(k,1) lightoilTheta(k,2) 0 lightoilTheta(k,3) 0 lightoilTheta(k,4) 0 lightoilTheta(k,6) 0 lightoilTheta(k,5) 0 ];
        end;
end;            
toc;
%%
lightoilTheta(:,2)=abs(lightoilTheta(:,2))+0.01;
lightoilTheta(1:4,3:4)=abs(lightoilTheta(1:4,3:4));
lightoilTheta(1:4,4)=lightoilTheta(1:4,4)+.01;
lightoilTheta(5:6,3)=abs(lightoilTheta(5:6,3))+0.0001;
lightoilTheta(5:6,4:5)=abs(lightoilTheta(5:6,4:5));
lightoilTheta(1:4,5)=abs(lightoilTheta(1:4,5));
lightoilTheta(5:6,10:11)=abs(lightoilTheta(5:6,10:11));
sigLO=lightoilTheta(2,3);
Nparam=initval_M(1:6,1)';

%% 
RPort=[RGS RNG RLO];
T=255;
conf=95;
Rport=RPort(1:T,:);
w=[mean(RGS) mean(RNG) mean(RLO)]./(mean(RGS)+mean(RNG)+mean(RLO));
%w=[1/3 1/3 1/3];%1-w;
EPort=[EGS ENG ELO];
EPort=EPort(1:T,:);
Esig=[sigGS sigNG sigLO];
RP=log(RPort(1:T,:))*w';
EP=log(EPort(1:T,:))*w';
sigmaP=log(sum(repmat(w.^2.*(exp(Esig.^2)-1),T,1).*exp((2*log(EPort)+repmat(Esig.^2,T,1))),2)./sum(repmat(w,T,1).*exp(log(EPort)+repmat((Esig.^2)./2,T,1)),2));
muP=log(sum(repmat(w,T,1).*exp(log(EPort)+repmat((Esig.^2)./2,T,1)),2)-0.5*sigmaP.^2);
P=logninv(1-conf/100,muP,sigmaP);
a=-norminv(1-conf/100);
VaR=EP-sqrt(1/T)*sigmaP;
% VaR=EP-sqrt(1/T)*P.*sigmaP;
EXC=sum((RP-VaR<0));
kup=kupiec(EXC,1-conf/100,T);
plot(RP,'r');hold on;
plot(VaR,'.')

%matlabpool close;