function [z, commodity] = seasonalityfilter(c,y,x0,delta,T,tag,D)
[m, n]=size(y);
mu=c(1);
theta=abs(c(2));
kap=abs(c(3))+0.01;
Sigma=abs(c(4));
Q=eye(n)*(abs(c(5))+0.01);
QQ=Q^2;
p=abs(c(6));
lambda=c(7);
ph=c(9);
zeta=c(9);
psi=c(10);
b=c(11);


%%----------------
slk=Sigma*lambda;
alpha = @(b,zeta,psi,ph,t) b+zeta*sin(psi*t+ph);

%%----------------
x_old=[x0 zeros(1,m)];
x_new=zeros(1,m+1);
B=exp(-kap*delta);
g=mu/kap*(1-exp(-kap*delta));
RR=Sigma^2*0.5/kap*(1-exp(-2*kap*delta))+theta/kap/kap*(1-exp(-kap*delta))^2;
L=T'*ones(1,m+2);
j=ones(n,1)*(0:m+1).*delta;
Tc=(L-j);
A=exp(-kap*Tc);
y=y';
BB=B^2;
dg=alpha(b,zeta,psi,ph,D)';
d=(mu+slk)./kap.*(1-exp(-kap*Tc))+Sigma^2*0.25/kap*(1-exp(-2*kap*Tc))+theta/2/kap/kap*(1-exp(-kap*Tc)).^2;

switch lower(tag)
    case {'calibration'}
        z=0;
        for i=2:m
        sig=A(:,i)*p*A(:,i)'+QQ;
        k=p*A(:,i)'/sig;
        x_new(:,i)=B*x_old(:,i)+g;
        p=BB*p+RR-BB*p^2*A(:,i)'/sig*A(:,i);
        v=y(:,i)-(A(:,i)*x_new(:,i)+d(:,i)+dg);
        z=z+log(det(sig))+v'/sig*v;
        x_old(:,i+1)=x_new(:,i)+k*v;
        end;
     

    case {'test'}
        commodity=B*x_old(:,1)+g;
        z=A(:,2)*commodity+d(:,2)+dg;

end

