%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Executable Script.
% Author: Suren Islyaev
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clc;
clear;
%Load Data:
load gasoline.mat;
warning off all;

var_1=gasoline(1:end-1,:);

r=price2ret(var_1(:,1));
N=length(r);

model = arima('ARLags',1,'Variance',garch(1,1));

fit=estimate(model,r);

[res,V,LogL] = infer(fit,r);

figure(1); clf;
subplot(2,1,1)
plot(V)
xlim([0,N])
title('Conditional Variance')

subplot(2,1,2)
plot(res./sqrt(V))
xlim([0,N])
title('Standardized Residuals')

model.Distribution = 't';
fitT = estimate(model,r,'Variance0',{'Constant0',0.001});

[resT,VT,LogLT] = infer(fitT,r);
figure(2); clf;
subplot(2,1,1)
plot(VT)
xlim([0,N])
title('Conditional Variance')

subplot(2,1,2)
plot(resT./sqrt(VT))
xlim([0,N])
title('Standardized Residuals')


[aic,bic] = aicbic([LogL,LogLT],[5,6],N)
