function [particle, W, RMSE, MRAEi]=particle_filter(func,vec,vecSeas,observation,CM,delta,t,T,W,xt,risk)
Npart=length(W);
particle=func.generator(vec,xt,delta,Npart,risk,'KappaRandom')';
%plot(particle,'DisplayName','particle','YDataSource','particle');figure(gcf)
dimT=length(T);
v=zeros(dimT,Npart);
M=zeros(dimT,Npart);
for i=1:Npart
    M(:,i)=func.futprice(delta,t,T,vec,vecSeas,particle(i,:),risk)';
    v(:,i)=M(:,i)-observation;
end

w=W.*mvnpdf(v',zeros(1,length(T)),CM);

w(isnan(w))=0;
W=w./sum(w);
%abs(r)*(T*delta-t)'.*
Neff=1/sum(W.^2);
if Neff<Npart 
    [particle, W]=resample(particle,W);
end;
    RMSE=sqrt(sum((v.^2)/Npart,2));   
    MRAEi=abs(mean(M,2)-observation)./observation;