function [risk, Noise, X_filtered, particle, W, RMSE, MRAEi]=particle_filter(func,vec,vecSeas,observation,CM,delta,t,T,W,xt,risk,st)
Npart=length(W);
NT=Npart/2;
particle=func.generator(vec,xt,delta,Npart,'Lambda')';
%plot(particle,'DisplayName','particle','YDataSource','particle');figure(gcf)
dimT=length(T);
v=zeros(dimT,Npart);
M=zeros(dimT,Npart);
for i=1:Npart
    M(:,i)=func.futprice(delta,t,T,vec,vecSeas,particle(i,:),risk)';
    v(:,i)=M(:,i)-observation;
end

w=W.*mvnpdf(v',zeros(1,length(T)),CM);

w(isnan(w))=0;
W=w./sum(w);
%abs(r)*(T*delta-t)'.*
Neff=1/sum(W.^2);
if Neff<NT 
    [particle, W]=resample(particle,W);
end;
    RMSE=sqrt(sum((v.^2)/Npart,2));   
    MRAEi=abs(mean(M,2)-observation)./observation;
    
    X_filtered=W'*particle;
    
    M=func.futprice(delta,t,T,vec,vecSeas,X_filtered,risk)';
    v=M-observation;
    Noise=diag(v.^2+.01);
persistent options_r;
 persistent initcond_r;
 if isempty(options_r);
     options_r=optimset('MaxFunEvals',	1000,...
                     'MaxIter',1000,...
                     'Algorithm','interior-point',...
                     'Display','off',...
                     'TolX',1e-30,...
                    'UseParallel','always',...
                     'TolFun',1e-30);
                 if length(risk)>2
                    initcond_r=[  100 ,   100,    10; risk; -100   -100   -10  ] ;
                 else initcond_r=[  100 ,   100,    10; risk 0; -100   -100   -10  ] ;
                 end
       risk=fmincon(@(risk) minimize_risk(func.futprice, delta,t,T,vec,vecSeas,xt,risk,observation), risk,[],[]...
             ,[],[],initcond_r(3,:),initcond_r(1,:),[],options_r);
 end
 if rem(st,10)==0
    risk=fmincon(@(risk) minimize_risk(func.futprice, delta,t,T,vec,vecSeas,xt,risk,observation), risk,[],[]...
        ,[],[],initcond_r(3,:),initcond_r(1,:),[],options_r);
 end;