function main(myfunction,data, Theta, samplesize,testsample,ik)
[n,m]=size(data);
n_new=samplesize+testsample;
%% Initial values
delta=1/252; %timestep weekly
T=data(n,2:m)*delta; % times to maturity 
x=log(data(1:n_new,1));    %vector of commodity prices price at time t=0
y=log(data(1:n_new,2:m)); %180 data points for calibration
y=y(~isinf(x),:);
x=x(~isinf(x));
n=length(x)-1;


%% Initialise output
futures=zeros(m-1,n-samplesize-1);
commodity=zeros(n-samplesize-1,1);
Tn=T-samplesize*delta;
k=0;
%% Generating the output
for i=samplesize:n-1

[futures(:,k+1), commodity(k+1)]=myfunction(Theta,y(samplesize+k,:)...
    ,x(samplesize+k),delta,Tn,'test',i);
k=k+1;
end;
 %%
 realComm=exp(x(samplesize+1:n));
 comcum=exp(commodity(1:end));
 X=realComm-comcum;
 N=length(X);
 RAE=abs(X)./realComm*100;
 MRAE=mean(RAE);
 RMSE=sqrt(sum((X).^2)/N);
 figure(ik);
 a=plot(realComm); hold on;
 b=plot(comcum,['.','r']);
 legend([a,b],'Observed Price','Estimated Price','Location','Best');
 xlabel('Day');
 ylabel('Commodity Price ($)');
 
end

