function [z, commodity]=twostatefilterseasonality(c,y,x0,delta,T,tag,l)
[m, n]=size(y);
a2=c(1);
k=c(2);
sigma1=c(3);
sigma2=c(4);
Q=eye(n)*c(5);
QQ=Q^2;
l1=c(6);
l2=c(7);
rho=c(8);
p=[c(9) 0; 0 c(10)];
ph=c(11);
zeta=c(12);
psi=c(13);
b=c(14);
expkd=exp(-k*delta);
%--------------------------
alpha = @(zeta,psi,ph,t,delta) b+zeta*(sin(psi*(t+delta)+ph));
t=l:l+m+1;
t=ones(n,1)*t*delta;
%-----------------------------------%
x_old=[0 zeros(1,m);x0 zeros(1,m)];
x_new=[zeros(1,m+1);zeros(1,m+1)];
%___________________________________%
B=[expkd 0; 0 1];
RR=[sigma1^2*0.5/k*(1-expkd^2) rho*sigma1*sigma2/k*(1-expkd);...
      rho*sigma1*sigma2/k*(1-expkd) sigma2^2*delta];
g=[0;a2*delta];
Af=@(t) [exp(-k*t) ones(length(t),1)];

Tv=repmat(T',1,m+2)-repmat(0:m+1,n,1)*delta;
dg=alpha(zeta,psi,ph,t,Tv);
d=l1*sigma1/k*(1-exp(-k*Tv))+(a2+l2*sigma2)*Tv+...
    sigma1^2*0.25/k*(1-exp(-2*k*Tv))+...
    rho*sigma1*sigma2/k*(1-exp(-k*Tv))+0.5*sigma2^2*Tv+dg;

y=y';



switch lower(tag)
    case {'calibration'}
        z=0;
        for i=2:m-1
            A=Af(Tv(:,i+1));
            x_new(:,i-1)=B*x_old(:,i-1)+g;
            v=y(:,i)-(A*(x_new(:,i-1))+d(:,i));
            sig=A*p*A'+QQ;
            k=p*A'/sig;
            x_old(:,i)=x_new(:,i-1)+k*v;
            p=B*p*B'+RR-B*p*A'*(sig\A)*p*B';
            z=z+log(det(sig))+v'*(sig\v);
        end;
       
    case {'test'}
            commodity=B*x_old(:,1)+g;
            z=Af(Tv(:,2))*commodity+d(:,2);
            commodity=sum(commodity);
end;        
        
        