clc;clear;
load GasolineNew.mat; % Load gasoline data
load HB_Nat_Gas_new.mat;  % Load Natgas Data
load lightoil.mat; %Load Light Oil data
lightoil=lightoil(608:end,:); lightoil(end,2:end)=lightoil(end,2:end)-607;
Precision=4000; %number of function evaluations and maximum iterations 

calibrationsample=300; % number of datapoints for calibration
testsample=301; % number of datapoints for out-of-sample performance
x0=[6 1 0.01 .002]; % initial guess for x
Nparam=4;% number of degrees of freedom of the model
%%%%%%%%%%%%%%%%%%%%%%%%%%Evaluate Parameters, Errors and Log MLEs
[gasolineTheta,gasolineRAE(:,1),gasolineMRAE,...
            gasolineRMSE,gasolinefval]=main(@commodityforecast3,...
            GasolineNew,x0,...
            Precision,calibrationsample,testsample);
x0=[6 2 0.01 .008];
[natgasTheta,natgasRAE(:,1),natgasMRAE,...
            natgasRMSE,natgasfval]=main(@commodityforecast3,...
            HB_Nat_Gas_new,x0,...
            Precision,calibrationsample,testsample);
        
[lightoilTheta,lightoilRAE(:,1),lightoilMRAE,...
            lightoilRMSE,lightoilfval]=main(@commodityforecast3,...
            lightoil,x0,...
            Precision,calibrationsample,testsample);
%Calculate AIC Values
AIC_natgas=natgasfval+2*Nparam+(2*Nparam.*(Nparam+1))./(calibrationsample-Nparam-1);
AIC_gasoline=gasolinefval+2*Nparam+(2*Nparam.*(Nparam+1))./(calibrationsample-Nparam-1);
AIC_lightoil=gasolinefval+2*Nparam+(2*Nparam.*(Nparam+1))./(calibrationsample-Nparam-1);
%%%Prepare data before saving to excel file
%Error Table
ErrorTable=[gasolineMRAE,gasolineRMSE,-gasolinefval,AIC_gasoline;...
            natgasMRAE, natgasRMSE,-natgasfval,AIC_natgas;...
            lightoilMRAE, lightoilRMSE,-lightoilfval,AIC_lightoil];
%Parameter table
ParamTable=[gasolineTheta;natgasTheta;lightoilTheta];     
ParamTable(:,2)=abs(ParamTable(:,2));
ParamTable(:,4)=ParamTable(:,4).^2;
ParamTable(:,3)=ParamTable(:,3).^2;
%save to the excel file                   
filename='results_murandom_new.xlsx';
xlswrite(filename,...
    ErrorTable,'Sheet1','C2:F8');
xlswrite(filename,...
    ParamTable,'Sheet1','C6:F8');