clc;clear;
load gasoline.mat; % Load gasoline data
load HBnatgas.mat;  % Load Natgas Data
load lightoil.mat;  %Load Light Oil data
Precision=50000; %number of function evaluations and maximum iterations 
calibrationsample=300; % number of datapoints for calibration
testsample=301; % number of datapoints for out-of-sample performance
x0=[2 0.1 0.8 0.1]; % initial guess for x
Nparam=4;% number of degrees of freedom of the model

%%%%%%%%%%%%%%%%%%%%%%%%%%Evaluate Parameters, Errors and Log MLEs
[gasolineTheta,gasolineRAE(:,1),gasolineMRAE,...
            gasolineRMSE,gasolinefval]=main(@commodityforecast3,...
            gasoline,x0,...
            Precision,calibrationsample,testsample);
[natgasTheta,natgasRAE(:,1),natgasMRAE,...
            natgasRMSE,natgasfval]=main(@commodityforecast3,...
            HBnatgas,x0,...
            Precision,calibrationsample,testsample);
[lightoilTheta,lightoilRAE(:,1),lightoilMRAE,...
            lightoilRMSE,lightoilfval]=main(@commodityforecast3,...
            lightoil,x0,...
            Precision,calibrationsample,testsample);
%Calculate AIC Values
AIC_natgas=natgasfval+2*Nparam+(2*Nparam.*(Nparam+1))./(calibrationsample-Nparam-1);
AIC_gasoline=gasolinefval+2*Nparam+(2*Nparam.*(Nparam+1))./(calibrationsample-Nparam-1);
AIC_lightoil=gasolinefval+2*Nparam+(2*Nparam.*(Nparam+1))./(calibrationsample-Nparam-1);
%%%Prepare data before saving to excel file
%Error Table
ErrorTable=[gasolineMRAE,gasolineRMSE,gasolinefval;...
            natgasMRAE, natgasRMSE,natgasfval;...
            lightoilMRAE, lightoilRMSE,lightoilfval];
%Parameter table
ParamTable=[gasolineTheta;natgasTheta;lightoilTheta];       

ParamTable(:,2)=abs(ParamTable(:,2));
ParamTable(:,4)=ParamTable(:,4).^2;
ParamTable(:,3)=ParamTable(:,3).^2;
%save to the excel file                
filename='results_murandom.xlsx';
xlswrite(filename,...
    ErrorTable,'Sheet1','C2:E4');
xlswrite(filename,...
    ParamTable,'Sheet1','C6:F8');