clear;
clc;
clear;
D=xlsread('OptionPricesNEW_still.xlsx','DAX','B5:N104');
D(:,1)=xlsread('OptionPricesNEW_still.xlsx','DAX','B5:B104');
S=xlsread('OptionPricesNEW_still.xlsx','DAX','C3');
rf=rffix(D,S);
%%
delta=1/252;
[n,m]=size(D);
index=[true;false;false;true;false;false;true;true;false;false;false;true;true;false;true;false;true;true;true;false;false;true;false;false;false;true;true;true;false;false;true;false;true;true;false;false;false;false;false;false;true;false;false;true;false;true;false;true;false;false;false;true;false;false;false;false;false;false;false;false;false;false;false;true;false;false;true;false;false;false;false;false;false;false;false;false;false;false;false;false;true;false;true;false;true;false;false;false;false;false;false;false;false;false;true;false;true;false;false;true;];
%% In-Sample Data
inDAX=D(~index,:);
outDAX=D(index,:);
K=inDAX(:,1);
T=inDAX(:,3)*delta;
bid=inDAX(:,5);
ask=inDAX(:,4);
C=(bid+ask)./2;
r=rf(~index);

w= 1./abs(bid-ask).^2;
%% Out-of-Sample Data
outK=outDAX(:,1);
outT=outDAX(:,3)*delta;
outbid=outDAX(:,5);
outask=outDAX(:,4);
outC=(outbid+outask)./2;
outr=rf(index);
options=optimset('MaxFunEvals',2000,'MaxIter',2000,'TolFun',1e-17,'TolX',1e-17);
x0=[0.01,1,.2,.03,-.1];
ub=[2 10 10 1 1];
lb=[0 0 0 0 -1];
%%
tic;
 [Theta, fval]=lsqnonlin(@(c) HestonDeltafft(c,C,S,K,T,r,w),x0,lb,ub,options);
toc;
%%

v0=Theta(1);
kappa=Theta(2);
theta=Theta(3);
sigma=Theta(4);
rho=Theta(5);
%%
parfor i=1:length(C)
RAE(i)=abs(C(i)-HestonCallFft(kappa,theta,sigma,rho,v0,r(i),T(i),S,K(i)))/C(i);
inSE(i)=C(i)-HestonCallFft(kappa,theta,sigma,rho,v0,r(i),T(i),S,K(i));
end;
MaxErrorIn=max(RAE)*100;
inRMSE=sqrt(sum(inSE.^2)/length(inSE));
MRAE=mean(RAE)*100;
display(['Function Value  ',num2str(fval)]);
display(['Fitting Error (MRAE %) = ',num2str(MRAE),' %']);
display(['Fitting Error (RMSE) = ',num2str(inRMSE)]);
display(['Fitting Error (MaxError) = ',num2str(MaxErrorIn)]);
%%

parfor i=1:length(outC)
outRAE(i)=abs(outC(i)-HestonCallFft(kappa,theta,sigma,rho,v0,outr(i),outT(i),S,outK(i)))/outC(i);
outSE(i)=outC(i)-HestonCallFft(kappa,theta,sigma,rho,v0,outr(i),outT(i),S,outK(i));
end;
MaxErrorOut=max(outRAE)*100;
outRMSE=sqrt(sum(outSE.^2)/length(outSE));
 MRAEout=mean(outRAE)*100;
 display(['Out of Sample Error (MRAE %) = ',num2str(MRAEout),' %']);
 display(['Out-Of-Sample Error (RMSE) = ',num2str(outRMSE)]);
display(['Out-ofSample (MaxError) = ',num2str(MaxErrorOut)]);
 I=2*kappa*theta-sigma^2;
display(['Theta = ' num2str(Theta)]);
if I>0
    display('Parameters are ok');
else
    display('Parameters are wrong');
end; 


% Elapsed time is 37.308542 seconds.
% Function Value  14.0642
% Fitting Error (MRAE %) = 4.2477 %
% Fitting Error (RMSE) = 11.7281
% Fitting Error (MaxError) = 10.3083
% Out of Sample Error (MRAE %) = 4.3829 %
% Out-Of-Sample Error (RMSE) = 12.4758
% Out-ofSample (MaxError) = 9.6405
% Theta = 0.036695          10  2.2204e-14           1    -0.36891
% Parameters are wrong
