clear;
clc;
clear;
D=xlsread('OptionPricesNEW_still.xlsx','FTSE100','B5:H104');
S=xlsread('OptionPricesNEW_still.xlsx','FTSE100','C3');
rf=rffix(D,S);
%%
delta=1/252;
[n,m]=size(D);
%index=(rand(n,1)<.25);
index=[true;true;true;false;true;false;false;false;false;false;false;false;true;false;false;true;false;false;false;true;false;false;true;false;false;false;true;false;true;false;false;false;false;false;true;false;true;false;false;false;true;false;true;false;true;true;false;false;true;false;false;true;false;false;true;false;false;false;false;false;false;true;false;false;false;false;false;true;false;false;false;false;false;false;false;true;false;false;false;true;false;true;false;false;false;true;false;false;false;false;false;false;false;false;true;false;false;false;false;false;];
%% In-Sample Data
inFTSE100=D(~index,:);
outFTSE100=D(index,:);
K=inFTSE100(:,1);
T=inFTSE100(:,3)*delta;
bid=inFTSE100(:,5);
ask=inFTSE100(:,4);
C=(bid+ask)./2;
r=rf(~index);

w= 1./abs(bid-ask).^2;
%% Out-of-Sample Data
outK=outFTSE100(:,1);
outT=outFTSE100(:,3)*delta;
outbid=outFTSE100(:,5);
outask=outFTSE100(:,4);
outC=(outbid+outask)./2;
outr=rf(index);
options=optimset('MaxFunEvals',2000,'MaxIter',2000,'TolFun',1e-17,'TolX',1e-17);
x0=[0.02,.1,.2,.3,.1];
ub=[1 2 10 1 1];
lb=[0 0 0 0 -1];
%%
tic;
 [Theta, fval]=lsqnonlin(@(c) HestonDeltafft(c,C,S,K,T,r,w),x0,lb,ub,options);
toc;
%%

v0=Theta(1);
kappa=Theta(2);
theta=Theta(3);
sigma=Theta(4);
rho=Theta(5);
%%
parfor i=1:length(C)
RAE(i)=abs(C(i)-HestonCallFft(kappa,theta,sigma,rho,v0,r(i),T(i),S,K(i)))/C(i);
inSE(i)=C(i)-HestonCallFft(kappa,theta,sigma,rho,v0,r(i),T(i),S,K(i));
end;
MaxErrorIn=max(RAE)*100;
inRMSE=sqrt(sum(inSE.^2)/length(inSE));
MRAE=mean(RAE)*100;
display(['Function Value  ',num2str(fval)]);
display(['Fitting Error (MRAE %) = ',num2str(MRAE),' %']);
display(['Fitting Error (RMSE) = ',num2str(inRMSE)]);
display(['Fitting Error (MaxError) = ',num2str(MaxErrorIn)]);
%%

parfor i=1:length(outC)
outRAE(i)=abs(outC(i)-HestonCallFft(kappa,theta,sigma,rho,v0,outr(i),outT(i),S,outK(i)))/outC(i);
outSE(i)=outC(i)-HestonCallFft(kappa,theta,sigma,rho,v0,outr(i),outT(i),S,outK(i));
end;
MaxErrorOut=max(outRAE)*100;
outRMSE=sqrt(sum(outSE.^2)/length(outSE));
 MRAEout=mean(outRAE)*100;
 display(['Out of Sample Error (MRAE %) = ',num2str(MRAEout),' %']);
 display(['Out-Of-Sample Error (RMSE) = ',num2str(outRMSE)]);
display(['Out-ofSample (MaxError) = ',num2str(MaxErrorOut)]);
 I=2*kappa*theta-sigma^2;
display(['Theta = ' num2str(Theta)]);
if I>0
    display('Parameters are ok');
else
    display('Parameters are wrong');
end; 