clear;
clc;
clear;
D=xlsread('OptionPricesNEW_still.xlsx','SNP500','H5:N104');
D(:,1)=xlsread('OptionPricesNEW_still.xlsx','SNP500','B5:B104');
S=xlsread('OptionPricesNEW_still.xlsx','SNP500','L3');
rf=rffix(D,S);
%%
delta=1/252;
[n,m]=size(D);
index=[true;false;false;false;false;false;false;false;true;false;true;true;true;false;true;false;true;false;true;false;false;true;true;true;false;false;true;false;false;false;false;false;false;true;false;false;false;false;false;true;false;false;false;false;false;true;false;false;false;false;false;false;true;false;false;false;false;false;false;false;false;true;true;true;false;false;false;false;true;false;false;true;true;false;false;false;false;false;false;false;false;false;false;false;false;false;true;false;true;true;false;false;false;false;false;false;false;false;true;true;];
%% In-Sample Data
inSANDP500=D(~index,:);
outSANDP500=D(index,:);
K=inSANDP500(:,1);
T=inSANDP500(:,3)*delta;
bid=inSANDP500(:,5);
ask=inSANDP500(:,4);
C=(bid+ask)./2;
r=rf(~index);

w= 1./abs(bid-ask).^2;
%% Out-of-Sample Data
outK=outSANDP500(:,1);
outT=outSANDP500(:,3)*delta;
outbid=outSANDP500(:,5);
outask=outSANDP500(:,4);
outC=(outbid+outask)./2;
outr=rf(index);
options=optimset('MaxFunEvals',2000,'MaxIter',2000,'TolFun',1e-17,'TolX',1e-17);
x0=[0.0249102808127345,9.99999999999996,2.22092692122258e-14,0.999444691271866,-0.417109830464883;];
ub=[1 10 10 1 1];
lb=[0 0 0 0 -1];
%%
tic;
 [Theta, fval]=lsqnonlin(@(c) HestonDeltafft(c,C,S,K,T,r,w),x0,lb,ub,options);
toc;
%%

v0=Theta(1);
kappa=Theta(2);
theta=Theta(3);
sigma=Theta(4);
rho=Theta(5);
%%
parfor i=1:length(C)
RAE(i)=abs(C(i)-HestonCallFft(kappa,theta,sigma,rho,v0,r(i),T(i),S,K(i)))/C(i);
inSE(i)=C(i)-HestonCallFft(kappa,theta,sigma,rho,v0,r(i),T(i),S,K(i));
end;
MaxErrorIn=max(RAE)*100;
inRMSE=sqrt(sum(inSE.^2)/length(inSE));
MRAE=mean(RAE)*100;
display(['Function Value  ',num2str(fval)]);
display(['Fitting Error (MRAE %) = ',num2str(MRAE),' %']);
display(['Fitting Error (RMSE) = ',num2str(inRMSE)]);
display(['Fitting Error (MaxError) = ',num2str(MaxErrorIn)]);
%%

parfor i=1:length(outC)
outRAE(i)=abs(outC(i)-HestonCallFft(kappa,theta,sigma,rho,v0,outr(i),outT(i),S,outK(i)))/outC(i);
outSE(i)=outC(i)-HestonCallFft(kappa,theta,sigma,rho,v0,outr(i),outT(i),S,outK(i));
end;
MaxErrorOut=max(outRAE)*100;
outRMSE=sqrt(sum(outSE.^2)/length(outSE));
 MRAEout=mean(outRAE)*100;
 display(['Out of Sample Error (MRAE %) = ',num2str(MRAEout),' %']);
 display(['Out-Of-Sample Error (RMSE) = ',num2str(outRMSE)]);
display(['Out-ofSample (MaxError) = ',num2str(MaxErrorOut)]);
 I=2*kappa*theta-sigma^2;
display(['Theta = ' num2str(Theta)]);
if I>0
    display('Parameters are ok');
else
    display('Parameters are wrong');
end;


% Elapsed time is 301.077687 seconds.
% Function Value  165.739
% Fitting Error (MRAE %) = 8.0787 %
% Fitting Error (RMSE) = 2.6361
% Fitting Error (MaxError) = 24.1076
% Out of Sample Error (MRAE %) = 7.1344 %
% Out-Of-Sample Error (RMSE) = 2.1358
% Out-ofSample (MaxError) = 17.0987
% Theta = 0.017424          10  2.2205e-14           1     0.18487
% Parameters are wrong
 