clear;
clc;
clear;
D=xlsread('OptionPricesDAX_FTSE_SNP_still.xlsx','FTSE','F5:L104');
K=xlsread('OptionPricesDAX_FTSE_SNP_still.xlsx','FTSE','B5:B104');
S=xlsread('OptionPricesDAX_FTSE_SNP_still.xlsx','FTSE','C3');
    D=[K D];
D=D(~isnan(D(:,3)),:);
rf=rffix(D,S);
%%
diff=0.001;
delta=1/252;
[n,m]=size(D);
%% In-Sample Data

K=D(:,1);
T=D(:,2)*delta;
bid=D(:,3);
ask=D(:,4);
DeltaMarket=D(:,7);
GammaMarket=D(:,8);
C=(bid+ask)./2;
r=rf;

%% Run Bates Model
svj=[0.00652	0.52723	0.00114	0.03320	-1.00000	1.45964	0.00010	0.09139];

k=svj(2);
theta=svj(3); v0=svj(1);
rho= svj(5);
lambda=svj(6);
m_j=svj(7);
s_v=svj(4);
sigma_s=svj(8);
for i=1:n
[BatesDelta(i), BatesGamma(i)] = Hedging(@(S) batescall(k,theta,s_v,rho,v0,m_j,sigma_s,lambda,r(i),T(i),S,K(i)),S,diff);
end;
%% Run Heston Model
hest=[0.01238	0.85289	0.03141	0.00001	-0.83847];
k=hest(2);
theta=hest(3); v0=hest(1);
rho=hest(5);
s_v=hest(4);

for i=1:n
[HestonDelta(i), HestonGamma(i)] =Hedging(@(S0) hestoncall(k,theta,s_v,rho,v0,r(i),T(i),S0,K(i)),S,diff);
end;
%% Run MSV Model 
msv=[0.010000	0.215726	-0.392434	-0.233559	2.443308];

s0=msv(2);
s1=msv(3);
s2=msv(4);
lambda=sqrt(msv(5));
k=msv(1);
for i=1:n
[HOMSVDelta(i), HOMSVGamma(i)]=Hedging(@(S0) homsv(s0,s1,s2,lambda,k,S0,K(i),T(i),r(i)),S,diff);
end;

figure(1);clf;
z=get(gcf,'Position');
set(gcf,'Position',z.*[.5 .5 1.5 1.5]);
a=plot(HOMSVDelta,'*','Color',[0 0 0],'Marker','o','LineStyle','none');
hold on;
b=plot(HestonDelta,'k');
c=plot(BatesDelta,':','Color',[0 0 0]);
%d=plot(DeltaMarket,'.','Color',[0 0 0]);
xlabel('Option Number')
ylabel('Delta')
% legend([a,b,c,d],'MSV','Heston','Bates','DeltaMarket');
legend([a,b,c],'MSV','Heston','Bates');

figure(2);clf;
z=get(gcf,'Position');
set(gcf,'Position',z.*[.5 .5 1.5 1.5]);
a=plot(HOMSVGamma,'*','Color',[0 0 0],'Marker','o','LineStyle','none');
hold on;
b=plot(HestonGamma,'k');
c=plot(BatesGamma,':','Color',[0 0 0]);
%d=plot(GammaMarket,'.','Color',[0 0 0]);
% legend([a,b],'MSV','Heston');
legend([a,b,c],'MSV','Heston','Bates');
xlabel('Option Number')
ylabel('Gamma')