clear;
clc;
clear;
D=xlsread('OptionPricesDAX_FTSE_SNP_still.xlsx','DAX','F5:L104');
K=xlsread('OptionPricesDAX_FTSE_SNP_still.xlsx','DAX','B5:B104');
S=xlsread('OptionPricesDAX_FTSE_SNP_still.xlsx','DAX','C3');
    D=[K D];
D=D(~isnan(D(:,7)),:);
rf=rffix(D,S);
%%
diff=0.001;
delta=1/252;
[n,m]=size(D);
%% In-Sample Data

K=D(:,1);
T=D(:,2)*delta;
bid=D(:,3);
ask=D(:,4);
DeltaMarket=D(:,7);
GammaMarket=D(:,8);
C=(bid+ask)./2;
r=rf;

%% Run Bates Model
svj=[0.00841	0.41768	0.07278	0.00012	-0.58158	0.17521	0.31796	0.10289];

k=svj(2);
theta=svj(3); v0=svj(1);
rho= svj(5);
lambda=svj(6);
m_j=svj(7);
s_v=svj(4);
sigma_s=svj(8);
for i=1:n
[BatesDelta(i), BatesGamma(i)] = Hedging(@(S) batescall(k,theta,s_v,rho,v0,m_j,sigma_s,lambda,r(i),T(i),S,K(i)),S,diff);
end;
%% Run Heston Model
hest=[0.00864	4.61077	0.03895	0.41761	1.00000];
k=hest(2);
theta=hest(3); v0=hest(1);
rho=hest(5);
s_v=hest(4);

for i=1:n
[HestonDelta(i), HestonGamma(i)] =Hedging(@(S0) hestoncall(k,theta,s_v,rho,v0,r(i),T(i),S0,K(i)),S,diff);
end;
%% Run HOMSV Model 
msv=[0.010000	-0.081007	1.130277	-0.384866	0.015264];

s0=msv(2);
s1=msv(3);
s2=msv(4);
lambda=sqrt(msv(5));
k=msv(1);
for i=1:n
[HOMSVDelta(i), HOMSVGamma(i)]=Hedging(@(S0) homsv(s0,s1,s2,lambda,k,S0,K(i),T(i),r(i)),S,diff);
end;

figure(1);clf;
z=get(gcf,'Position');
set(gcf,'Position',z.*[.5 .5 1.5 1.5]);
a=plot(HOMSVDelta,'*','Color',[0 0 0],'Marker','o','LineStyle','none');
hold on;
b=plot(HestonDelta,'k');
c=plot(BatesDelta,':','Color',[0 0 0]);
%d=plot(DeltaMarket,'.','Color',[0 0 0]);
xlabel('Option Number')
ylabel('Delta')
% legend([a,b,c,d],'MSV','Heston','Bates','DeltaMarket');
legend([a,b,c],'MSV','Heston','Bates');

figure(2);clf;
z=get(gcf,'Position');
set(gcf,'Position',z.*[.5 .5 1.5 1.5]);
a=plot(HOMSVGamma,'*','Color',[0 0 0],'Marker','o','LineStyle','none');
hold on;
b=plot(HestonGamma,'k');
c=plot(BatesGamma,':','Color',[0 0 0]);
%d=plot(GammaMarket,'.','Color',[0 0 0]);
% legend([a,b],'MSV','Heston');
legend([a,b,c],'MSV','Heston','Bates');
xlabel('Option Number')
ylabel('Gamma')