clear;
clc;
clear;
D=xlsread('OptionPricesNEW_still.xlsx','FTSE100','B5:H104');
S=xlsread('OptionPricesNEW_still.xlsx','FTSE100','C3');
rf=rffix(D,S);
%%
delta=1/252;
[n,m]=size(D);
index=[true;true;true;false;true;false;false;false;false;false;false;false;true;false;false;true;false;false;false;true;false;false;true;false;false;false;true;false;true;false;false;false;false;false;true;false;true;false;false;false;true;false;true;false;true;true;false;false;true;false;false;true;false;false;true;false;false;false;false;false;false;true;false;false;false;false;false;true;false;false;false;false;false;false;false;true;false;false;false;true;false;true;false;false;false;true;false;false;false;false;false;false;false;false;true;false;false;false;false;false;];
%% In-Sample Data
inFTSE100=D(~index,:);
outFTSE100=D(index,:);
K=inFTSE100(:,1);
T=inFTSE100(:,3)*delta;
bid=inFTSE100(:,5);
ask=inFTSE100(:,4);
C=(bid+ask)./2;
r=rf(~index);

w= 1./abs(bid-ask).^2;
%% Out-of-Sample Data
outK=outFTSE100(:,1);
outT=outFTSE100(:,3)*delta;
outbid=outFTSE100(:,5);
outask=outFTSE100(:,4);
outC=(outbid+outask)./2;
outr=rf(index);
options=optimset('MaxFunEvals',2000,'MaxIter',2000,'TolFun',1e-17,'TolX',1e-17);
x0=[.4,.4,.10,0.1,-.1,1,1,1];
ub=[2 2 100 2 1 100 100 100];
lb=[0 0 0 0 -1 0 0 0];
%%
tic;
 [Theta, fval]=lsqnonlin(@(c) BCCDeltafft(c,C,S,K,T,r,w),x0,lb,ub,options);
toc;
%%
v0=Theta(1);
kappa=Theta(2);
theta=Theta(3);
sigma=Theta(4);
rho=Theta(5);
l=Theta(6);
a=Theta(7);
g=Theta(8);
%%
display('_______________InSample_______________');
parfor i=1:length(C)
RAE(i)=abs(C(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,r(i),0,T(i),S,K(i)))/C(i);
SE(i)=(C(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,r(i),0,T(i),S,K(i)))^2;
end;
RMSE=sqrt(sum(SE)/length(C));
MRAE=mean(RAE)*100;
display(['Function Value  ',num2str(fval)]);
display(['Fitting Error (MRAE %) = ',num2str(MRAE),' %']);
display(['Fitting Error (RMSE = ',num2str(RMSE)]);
display(['Max Error %=',num2str(max(RAE)*100)]);

%%
display('____________OutOfSample__________________');
for i=1:length(outC)
outRAE(i)=abs(outC(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,outr(i),0,outT(i),S,outK(i)))/outC(i);
outSE(i)=(C(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,r(i),0,T(i),S,K(i)))^2;
end;
outRMSE=sqrt(sum(outSE)/length(outC));
MRAEout=mean(outRAE)*100;
 display(['Out of Sample Error (MRAE %) = ',num2str(MRAEout),' %']);
 display(['Fitting Error (RMSE = ',num2str(outRMSE)]);
 display(['Max Error %=',num2str(max(outRAE)*100)]);
I=2*kappa*theta-sigma^2;
display(['Theta = ' num2str(Theta)]);
if I>0
    display('Parameters are ok');
else
    error('Parameters are wrong');
end;

% 
% Elapsed time is 125.363644 seconds.
% _______________InSample_______________
% Function Value  1.8019
% Fitting Error (MRAE %) = 10.4181 %
% Fitting Error (RMSE = 7.3507
% Max Error %=35.0734
% ____________OutOfSample__________________
% Out of Sample Error (MRAE %) = 7.8821 %
% Fitting Error (RMSE = 8.6409
% Max Error %=29.8353
% Theta = 0.014574           2  3.5841e-14           2    -0.38847  2.2204e-14      5.5781      1.0469