clear;
clc;
clear;
D=xlsread('OptionPricesNEW_still.xlsx','SNP500','N5:X104');
D(:,1)=xlsread('OptionPricesNEW_still.xlsx','SNP500','B5:B104');
S=xlsread('OptionPricesNEW_still.xlsx','SNP500','P3');
rf=rffix(D,S);
%%
delta=1/252;
[n,m]=size(D);
index=[true;false;false;false;false;false;false;false;true;false;true;true;true;false;true;false;true;false;true;false;false;true;true;true;false;false;true;false;false;false;false;false;false;true;false;false;false;false;false;true;false;false;false;false;false;true;false;false;false;false;false;false;true;false;false;false;false;false;false;false;false;true;true;true;false;false;false;false;true;false;false;true;true;false;false;false;false;false;false;false;false;false;false;false;false;false;true;false;true;true;false;false;false;false;false;false;false;false;true;true;];
%% In-Sample Data
inSANDP500=D(~index,:);
outSANDP500=D(index,:);
K=inSANDP500(:,1);
T=inSANDP500(:,3)*delta;
bid=inSANDP500(:,5);
ask=inSANDP500(:,4);
C=(bid+ask)./2;
r=rf(~index);

w= 1./abs(bid-ask).^2;
%% Out-of-Sample Data
outK=outSANDP500(:,1);
outT=outSANDP500(:,3)*delta;
outbid=outSANDP500(:,5);
outask=outSANDP500(:,4);
outC=(outbid+outask)./2;
outr=rf(index);
options=optimset('MaxFunEvals',2000,'MaxIter',2000,'TolFun',1e-17,'TolX',1e-17);
x0=[.4,.4,.10,0.1,-.1,1,1,1];
ub=[2 2 100 2 1 100 100 100];
lb=[0 0 0 0 -1 0 0 0];
%%
tic;
 [Theta, fval]=lsqnonlin(@(c) BCCDeltafft(c,C,S,K,T,r,w),x0,lb,ub,options);
toc;
%%
v0=Theta(1);
kappa=Theta(2);
theta=Theta(3);
sigma=Theta(4);
rho=Theta(5);
l=Theta(6);
a=Theta(7);
g=Theta(8);
%%
display('_______________InSample_______________');
parfor i=1:length(C)
RAE(i)=abs(C(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,r(i),0,T(i),S,K(i)))/C(i);
SE(i)=(C(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,r(i),0,T(i),S,K(i)))^2;
end;
RMSE=sqrt(sum(SE)/length(C));
MRAE=mean(RAE)*100;
display(['Function Value  ',num2str(fval)]);
display(['Fitting Error (MRAE %) = ',num2str(MRAE),' %']);
display(['Fitting Error (RMSE = ',num2str(RMSE)]);
display(['Max Error %=',num2str(max(RAE)*100)]);

%%
display('____________OutOfSample__________________');
for i=1:length(outC)
outRAE(i)=abs(outC(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,outr(i),0,outT(i),S,outK(i)))/outC(i);
outSE(i)=(C(i)-BatesFFT(kappa,theta,sigma,rho,v0,l,a,g,r(i),0,T(i),S,K(i)))^2;
end;
outRMSE=sqrt(sum(outSE)/length(outC));
MRAEout=mean(outRAE)*100;
 display(['Out of Sample Error (MRAE %) = ',num2str(MRAEout),' %']);
 display(['Fitting Error (RMSE = ',num2str(outRMSE)]);
 display(['Max Error %=',num2str(max(outRAE)*100)]);
I=2*kappa*theta-sigma^2;
display(['Theta = ' num2str(Theta)]);
if I>0
    display('Parameters are ok');
else
    error('Parameters are wrong');
end;