clear;
multicore=0;
if multicore==1
    matlabpool open local 4;
end;
%% Initial Parameters:
% T           r
% 0.099	0.001
% 0.2103	0.0014
% 0.3214	0.0018
% 0.43254	0.0022

r=.001;              % Risk-free rate
T=.099;                %Time to maturity
S0=7281.18;             %todays price
K=7300;              %Strike Price
barrier=7050;         %Barrier
N=1e4; n=N;        %N of simulations

%% Run Bates Model
          
k=10.26305;
theta=0.0177; v0=0.0209;
rho=-0.5838;
lambda=0.0095;
m_j=4.30875648765341e-08;
s_v=1.0120;
sigma_s=2.0246;

[Price1, conf1, Time1] = batesmontecarlo(k,theta,s_v,rho,v0,m_j,sigma_s,lambda,r,T,S0,K,N,n,barrier);

%% Run Heston Model

k=     3.2531;              
theta=0.03214; v0=0.01575;
rho=-0.24301;
s_v=0.99;


[Price2, conf2, Time2] = hestonmontecarlo(k,theta,s_v,rho,v0,r,T,S0,K,N,n,barrier);

%% Run HOMSV Model 
s0=0.0132;
s1=0.4493;
s2=0.3379;
lambda=.7458^2;
k=0.0230;

[Price3, conf3 ,Time3]=HOMSV(s0,s1,s2,lambda,k,S0,K,T,r,N,n,barrier);
%%
%xlswrite('results.xlsx',[T,r,Price1,conf1,Price2,conf2,Price3,conf3],'DAX26nov','A19:K19');
X=[Price1 Price2 Price3];
 boxplot([X' [conf1; conf2; conf3]]')
 set(gca, 'XTick',1:3, 'XTickLabel',{'Bates' 'Heston' 'MSV'})


if multicore==1
matlabpool close;
end;