function [Price,conf,Time]=HOMSV(s0,s1,s2,lambda,k,S0,K,T,r,PATHS,n,barrier)
Timer=clock;
mu=log(1+k^2)/2;
svol=log(1+k^2);
S = [S0 zeros(1,n)]; 
dt=T/n;
tau=T-(1:n+1)*dt;
sigmadet=(s0^2*exp(-lambda*tau)+s1^2*lambda.*tau.*exp(-lambda*tau)+s2^2);
payoff=zeros(PATHS,1);
sigma=lognrnd(mu,svol,1,PATHS)'*sigmadet;
for j=1:PATHS
    
    Zv = randn(1,n+1);
    for i = 2:n+1;
        S(i) = S(i-1)+ S(i-1)*r*dt + S(i-1).*sigma(j,i-1).*Zv(i-1)*sqrt(dt);
        if S(i)<=barrier
            break
        end;
    end
    if i==(n+1)
        payoff(j)=max(S(end)-K,0);
    end;
end;

Price = mean(payoff)*exp(-r*T); %Call option price
bm=std(payoff);
conf=[Price-1.96*bm/sqrt(PATHS),Price+1.96*bm/sqrt(PATHS)];
Time = etime(clock,Timer); %Stop the algorithm time