clear;
multicore=0;
if multicore==1
    matlabpool open local 4;
end;
%% Initial Parameters:
r=.003;              % Risk-free rate
T=.3134;                %Time to maturity
S0=1412.16;             %todays price
K=1420;              %Strike Price
barrier=1325;         %Barrier
N=1e4; n=N;        %N of simulations

%% Run Bates Model
            
k=5.23333;
theta=0.0146151; v0=0.0137896;
rho=-0.998468;
lambda=2.60578e-05;
m_j=100;
s_v=0.208913;
sigma_s=0.00001;

[Price1, conf1, Time1] = batesmontecarlo(k,theta,s_v,rho,v0,m_j,sigma_s,lambda,r,T,S0,K,N,n,barrier);

%% Run Heston Model
k=     1.0399;              
theta=0.055955; v0=0.026772;
rho=-0.35154;
s_v=2.0106;


[Price2, conf2, Time2] = hestonmontecarlo(k,theta,s_v,rho,v0,r,T,S0,K,N,n,barrier);

%% Run HOMSV Model

s0=0.1944;
s1=0.4526;
s2=0.2633;
lambda=.3090^2;
k=.01;

[Price3, conf3 ,Time3]=HOMSV(s0,s1,s2,lambda,k,S0,K,T,r,N,n,barrier);
%%
%xlswrite('results.xlsx',[barrier,Price1,conf1,Price2,conf2,Price3,conf3],'SnP5001stnov','B9:K9');
%xlswrite('results.xlsx',[T,r,Price1,conf1,Price2,conf2,Price3,conf3],'DAX26nov','A19:K19');
X=[Price1 Price2 Price3];
 boxplot([X' [conf1; conf2; conf3]]')
 set(gca, 'XTick',1:3, 'XTickLabel',{'Bates' 'Heston' 'MSV'})



if multicore==1
matlabpool close;
end;