clear;
multicore=0;
if multicore==1
    matlabpool open local 4;
end;
%% Initial Parameters:
r=.0056;              % Risk-free rate
T=.420635;                %Time to maturity
S0=5812.06;             %todays price
K=5820;              %Strike Price
barrier=5750;         %Barrier
N=1e4; n=N;        %N of simulations

%% Run Bates Model
k=100;
theta=.0065; v0=0.0151;
rho=-.9999;
lambda=6.6132;
m_j=.191;
s_v=0.9904;
sigma_s=0.00001;

[Price1, conf1, Time1] = batesmontecarlo(k,theta,s_v,rho,v0,m_j,sigma_s,lambda,r,T,S0,K,N,n,barrier);

%% Run Heston Model
k=4.7552;
theta=0.0085; v0=0.0096;
rho=-.999;
s_v=0.0118;


[Price2, conf2, Time2] = hestonmontecarlo(k,theta,s_v,rho,v0,r,T,S0,K,N,n,barrier);

%% Run HOMSV Model 
s0=0.1082;
s1=0.0027;
s2=0.2937;
lambda=1.3414;
k=0.0004;

[Price3, conf3 ,Time3]=HOMSV(s0,s1,s2,lambda,k,S0,K,T,r,N,n,barrier);
%%
%xlswrite('results.xlsx',[T,r,Price1,conf1,Price2,conf2,Price3,conf3],'A19:K19');

if multicore==1
matlabpool close;
end;