function [Price,conf,Time]=HOMSV_asian(s0,s1,s2,lambda,k,S0,T,r,PATHS,n)
Timer=clock;
mu=log(1+k^2)/2;
svol=log(1+k^2);
%A = zeros(1,n+1); %Initialise average
dt=T/n;
tau=T-(1:n+1)*dt;
sigmadet=(s0^2*exp(-lambda*tau)+s1^2*lambda.*tau.*exp(-lambda*tau)+s2^2);
sigma=lognrnd(mu,svol,1,PATHS)'*sigmadet;
payoff=zeros(PATHS,1);
for j=1:PATHS
    S=S0; Sm=S0;    
    Zv = randn(1,n+1);
    for i = 2:n+1;
        S = S+ S*r*dt + S.*sigma(j,i-1).*Zv(i-1)*sqrt(dt);
        Sm=Sm+S;
    end;
%        A(j)=Sm/n;
        payoff(j)=max(S-Sm/n,0);
end;


Price = mean(payoff)*exp(-r*T); %Call option price
bm=std(payoff);
conf=[Price-1.96*bm/sqrt(PATHS),Price+1.96*bm/sqrt(PATHS)];
Time = etime(clock,Timer); %Stop the algorithm time