function [Price,conf, Time] = hestonmontecarlo_asian(KAPPA,THETA,SIGMAv,RHO,V0,r,T,S0,PATHS,n)
Timer = clock; %Start the algorithm timer
dt = T/n; %Interval length
%A = zeros(1,n+1); %Initialise variance vector
%Simulate the diffusion part of the stock price process:
payoff=zeros(PATHS,1);
parfor j=1:PATHS
    V = V0; %Initialise variance vector
    S = S0; %Initialise price vector
    Sm=S0;
    Zv = randn(1,n+1);
    Zs = RHO*Zv+sqrt(1-RHO^2).*randn(1,n+1);
    for i = 2:n+1;
        S = S+ S*r*dt + S.*sqrt(max(V,0)).*Zs(i-1)*sqrt(dt);
        V = V+KAPPA.*(THETA-V).*dt+SIGMAv.*sqrt(max(V,0)).*Zv(i-1)*sqrt(dt);
    Sm=Sm+S;
    end;
%        A(j)=Sm/n;
        payoff(j)=max(S-Sm/n,0);
end;



Price = mean(payoff)*exp(-r*T); %Call option price
bm=std(payoff);
conf=[Price-1.96*bm/sqrt(PATHS),Price+1.96*bm/sqrt(PATHS)];
Time = etime(clock,Timer); %Stop the algorithm time